/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package pos.ar;

import com.ustasoft.component.GeneralFunction;
import com.ustasoft.component.MyRowRenderer;
import java.awt.Color;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFormattedTextField;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.table.DefaultTableModel;
import org.jdesktop.swingx.JXDatePicker;
import org.jdesktop.swingx.decorator.HighlighterFactory;

/**
 *
 * @author cak-ust
 */
public class FrmItemHistoryAR extends javax.swing.JInternalFrame {
    private Connection conn;
    private GeneralFunction fn =  GeneralFunction.getInstance();
    /**
     * Creates new form FrmItemHistoryAR
     */
    public FrmItemHistoryAR() {
        initComponents();
        txtCustomer.addFocusListener(txtFocusListener);
        txtKodeBarang.addFocusListener(txtFocusListener);
        jXTable1.setHighlighters(HighlighterFactory.createAlternateStriping());
        jXTable1.getColumn("Tanggal").setCellRenderer(new MyRowRenderer());
    }
    
    public void setConn(Connection c){
        this.conn=c;
    }
    
    private void udfLoad(){
        btnRefresh.requestFocus();
        if(lblIdBarang.getText().equalsIgnoreCase("")){
            JOptionPane.showMessageDialog(this, "Silahkan pilih item terlebih dulu!");
            txtKodeBarang.requestFocus();
            return ;
        }
        String sql="select * from fn_ar_item_history("+lblIdBarang.getText()+", "+fn.udfGetInt(txtCustomer.getText())+") "
                + "as (invoice_date date, invoice_no varchar, nama_Relasi varchar, \n" +
        "qty double precision, unit_price double precision, disc varchar, sub_total double precision, unit_code double precision)";
        ((DefaultTableModel)jXTable1.getModel()).setNumRows(0);
        try {
            ResultSet rs=conn.createStatement().executeQuery(sql);
            while(rs.next()){
                ((DefaultTableModel)jXTable1.getModel()).addRow(new Object[]{
                    rs.getDate("invoice_date"),
                    rs.getString("invoice_no"),
                    rs.getString("nama_relasi"),
                    rs.getDouble("qty"),
                    rs.getDouble("unit_price"),
                    rs.getString("disc"),
                    rs.getDouble("sub_total"),
                });
            }
            rs.close();
            if(jXTable1.getRowCount() > 0){
                jXTable1.setRowSelectionInterval(0, 0);
                jXTable1.setModel(fn.autoResizeColWidth(jXTable1, ((DefaultTableModel)jXTable1.getModel())).getModel());
            }
        } catch (SQLException ex) {
            Logger.getLogger(FrmItemHistoryAR.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        txtCustomer = new javax.swing.JTextField();
        lblCustomer = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        txtKodeBarang = new javax.swing.JTextField();
        lblNamaBarang = new javax.swing.JLabel();
        lblIdBarang = new javax.swing.JLabel();
        btnRefresh = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jXTable1 = new org.jdesktop.swingx.JXTable();

        setClosable(true);
        setIconifiable(true);
        setMaximizable(true);
        setResizable(true);
        setTitle("Histori Penjualan Per Item");
        addInternalFrameListener(new javax.swing.event.InternalFrameListener() {
            public void internalFrameActivated(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameClosed(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameClosing(javax.swing.event.InternalFrameEvent evt) {
                formInternalFrameClosing(evt);
            }
            public void internalFrameDeactivated(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameDeiconified(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameIconified(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameOpened(javax.swing.event.InternalFrameEvent evt) {
            }
        });

        jPanel1.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel1.setLayout(null);

        jLabel3.setText("Pelanggan : ");
        jPanel1.add(jLabel3);
        jLabel3.setBounds(10, 10, 75, 20);

        txtCustomer.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        txtCustomer.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                txtCustomerKeyReleased(evt);
            }
        });
        jPanel1.add(txtCustomer);
        txtCustomer.setBounds(85, 10, 80, 20);

        lblCustomer.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel1.add(lblCustomer);
        lblCustomer.setBounds(165, 10, 435, 20);

        jLabel4.setText("Nama Stok : ");
        jPanel1.add(jLabel4);
        jLabel4.setBounds(10, 35, 75, 20);

        txtKodeBarang.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        txtKodeBarang.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                txtKodeBarangKeyReleased(evt);
            }
        });
        jPanel1.add(txtKodeBarang);
        txtKodeBarang.setBounds(85, 35, 80, 20);

        lblNamaBarang.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel1.add(lblNamaBarang);
        lblNamaBarang.setBounds(165, 35, 385, 20);

        lblIdBarang.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel1.add(lblIdBarang);
        lblIdBarang.setBounds(550, 35, 50, 20);

        btnRefresh.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/images/arrow_refresh.png"))); // NOI18N
        btnRefresh.setText("Tampilkan");
        btnRefresh.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnRefreshActionPerformed(evt);
            }
        });
        jPanel1.add(btnRefresh);
        btnRefresh.setBounds(610, 35, 115, 25);

        jXTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Tanggal", "No. Invoice", "Pelanggan", "Qty", "Harga", "Diskon", "Sub Total"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.Object.class, java.lang.Object.class, java.lang.Object.class, java.lang.Double.class, java.lang.Double.class, java.lang.Object.class, java.lang.Double.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jXTable1.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jScrollPane1.setViewportView(jXTable1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(10, 10, 10)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 790, Short.MAX_VALUE)
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGap(7, 7, 7))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(75, 75, 75)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 255, Short.MAX_VALUE)
                .addGap(10, 10, 10))
            .addGroup(layout.createSequentialGroup()
                .addGap(11, 11, 11)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, 65, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        setBounds(0, 0, 823, 369);
    }// </editor-fold>//GEN-END:initComponents

    private void txtCustomerKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtCustomerKeyReleased
        String sQry="select id_relasi::varchar as id_customer, coalesce(nama_relasi,'') as nama_customer, "
        + "alamat||' - '||kota.nama_kota as alamat, coalesce(s.top,0) as top "
        + "from m_relasi s "
        + "left join m_kota kota on kota.id=s.id_kota "
        + "where tipe_relasi=0 and id_relasi::varchar||coalesce(nama_relasi,'')||"
        + "coalesce(alamat,'')||' - '||coalesce(kota.nama_kota,'') "
        + "ilike '%"+txtCustomer.getText()+"%' order by 2" ;
        fn.lookup(evt, new Object[]{lblCustomer}, sQry, txtCustomer.getWidth()+lblCustomer.getWidth(), 300);
    }//GEN-LAST:event_txtCustomerKeyReleased

    private void txtKodeBarangKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtKodeBarangKeyReleased
        fn.lookup(evt, new Object[]{lblNamaBarang, lblIdBarang}, "select coalesce(plu,'') as plu, "
                + "coalesce(nama_barang,'') as nama_barang, id::varchar as kode "
                + "from m_item i "
                + "where id::varchar||coalesce(plu,'')||coalesce(nama_barang,'') ilike '%"+txtKodeBarang.getText()+"%' "
                + "order by coalesce(plu,'')", 
                txtKodeBarang.getWidth()+lblNamaBarang.getWidth()+lblIdBarang.getWidth()+18, 150);
    }//GEN-LAST:event_txtKodeBarangKeyReleased

    private void btnRefreshActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnRefreshActionPerformed
        udfLoad();
    }//GEN-LAST:event_btnRefreshActionPerformed

    private void formInternalFrameClosing(javax.swing.event.InternalFrameEvent evt) {//GEN-FIRST:event_formInternalFrameClosing
        fn.setVisibleList(false);
    }//GEN-LAST:event_formInternalFrameClosing


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnRefresh;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private org.jdesktop.swingx.JXTable jXTable1;
    private javax.swing.JLabel lblCustomer;
    private javax.swing.JLabel lblIdBarang;
    private javax.swing.JLabel lblNamaBarang;
    private javax.swing.JTextField txtCustomer;
    private javax.swing.JTextField txtKodeBarang;
    // End of variables declaration//GEN-END:variables
    
    private FocusListener txtFocusListener=new FocusListener() {
        public void focusGained(FocusEvent e) {
            if(e.getSource() instanceof JTextField || e.getSource() instanceof JFormattedTextField ){
                ((JTextField)e.getSource()).setBackground(Color.YELLOW);
                if( (e.getSource() instanceof JTextField && ((JTextField)e.getSource()).getName()!=null && ((JTextField)e.getSource()).getName().equalsIgnoreCase("textEditor"))){
                    ((JTextField)e.getSource()).setSelectionStart(0);
                    ((JTextField)e.getSource()).setSelectionEnd(((JTextField)e.getSource()).getText().length());

                }
            }else if(e.getSource() instanceof JXDatePicker){
                ((JXDatePicker)e.getSource()).setBackground(Color.YELLOW);
            }
        }


        public void focusLost(FocusEvent e) {
            if(e.getSource() instanceof  JTextField||e.getSource() instanceof JFormattedTextField){
                ((JTextField)e.getSource()).setBackground(Color.WHITE);
           }
        }
    } ;
}
